=begin
#Cloudera DataBus Service

#Cloudera DataBus Service is a data transport infrastructure.

OpenAPI spec version: 0.1-SNAPSHOT

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.27

=end

require 'date'

module Dbus
  # Represents small unit of data going into a stream.
  class Record
    # Name of the target DataStream.
    attr_accessor :stream_name

    # Partition key. Variance should be high enough to ensure even distribution.
    attr_accessor :partition_key

    # Expected size of the payload in bytes, whether inlined or to be sent out of band.
    attr_accessor :payload_size

    # Arbitrary metadata that will be made available to subscribers of the message.
    attr_accessor :headers

    # Optional inlined payload encoded in base64 format. Decoded size cannot exceed 1MB.
    attr_accessor :payload

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'stream_name' => :'streamName',
        :'partition_key' => :'partitionKey',
        :'payload_size' => :'payloadSize',
        :'headers' => :'headers',
        :'payload' => :'payload'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'stream_name' => :'String',
        :'partition_key' => :'String',
        :'payload_size' => :'Integer',
        :'headers' => :'Array<Header>',
        :'payload' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'streamName')
        self.stream_name = attributes[:'streamName']
      end

      if attributes.has_key?(:'partitionKey')
        self.partition_key = attributes[:'partitionKey']
      end

      if attributes.has_key?(:'payloadSize')
        self.payload_size = attributes[:'payloadSize']
      end

      if attributes.has_key?(:'headers')
        if (value = attributes[:'headers']).is_a?(Array)
          self.headers = value
        end
      end

      if attributes.has_key?(:'payload')
        self.payload = attributes[:'payload']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @stream_name.nil?
        invalid_properties.push('invalid value for "stream_name", stream_name cannot be nil.')
      end

      if @partition_key.nil?
        invalid_properties.push('invalid value for "partition_key", partition_key cannot be nil.')
      end

      if @payload_size.nil?
        invalid_properties.push('invalid value for "payload_size", payload_size cannot be nil.')
      end

      if @headers.nil?
        invalid_properties.push('invalid value for "headers", headers cannot be nil.')
      end

      if !@payload.nil? && @payload.to_s.length > 1048576
        invalid_properties.push('invalid value for "payload", the character length must be smaller than or equal to 1048576.')
      end

      if !@payload.nil? && @payload.to_s.length < 0
        invalid_properties.push('invalid value for "payload", the character length must be great than or equal to 0.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @stream_name.nil?
      return false if @partition_key.nil?
      return false if @payload_size.nil?
      return false if @headers.nil?
      return false if !@payload.nil? && @payload.to_s.length > 1048576
      return false if !@payload.nil? && @payload.to_s.length < 0
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] payload Value to be assigned
    def payload=(payload)
      if !payload.nil? && payload.to_s.length > 1048576
        fail ArgumentError, 'invalid value for "payload", the character length must be smaller than or equal to 1048576.'
      end

      if !payload.nil? && payload.to_s.length < 0
        fail ArgumentError, 'invalid value for "payload", the character length must be great than or equal to 0.'
      end

      @payload = payload
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          stream_name == o.stream_name &&
          partition_key == o.partition_key &&
          payload_size == o.payload_size &&
          headers == o.headers &&
          payload == o.payload
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [stream_name, partition_key, payload_size, headers, payload].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = Dbus.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
